/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ ovlvO
//	FileName	motor.c
//	Version		1.00
//	MCU		R8C/25 type:R5F21258,clock:20MHz(XIN clock)
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/06/19	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	[^]vOłB
//	莞ԂƂɁA[^̑xƉ]ς܂B
	
	@\:PWM,^C}[RD

//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

  Copyright (C) Hokuto denshi Co,Ltd. 2008

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
#include "R8C25.h"


/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
long msec;		/*҂*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
#define MAX_DUTY 100
#define MIN_DUTY 0


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/
#define FORWARD		P0.BIT.P_4		/*[^]M|[g*/
#define BACK		P0.BIT.P_6		/*[^t]M|[g*/
#define PWM		TRDGRB0.WORD		/*DUTYݒ背WX^*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void driving_motor(short duty);
void RD_init(void);
void wait(const long sec);
void wait_timer(const long msec2);
void timer_interrupt(void);
void port_init(void);
void rx_str0(void);
void int0_func(void);
void int1_func(void);

/*
///////////////////////////////////////////////////////////////////////////////
//Main program
*/
void main(void){
	/*NbNݒ*/
	PRCR.BYTE = 0x01;		/*CM0,CM1,OCDɏ*/
	CM1.BIT.CM13 = 1;		/*XIN-XOUT [q*/
	CM0.BIT.CM05 = 0;		/*XINNbNU*/
	asm("NOP");			/*U莞Ԃ҂*/
	asm("NOP");
	asm("NOP");
	asm("NOP");
	OCD.BIT.OCD2 = 0;		/*XINNbNI*/
	
	port_init();
	RD_init();
	asm("MOV.B	#05H,0137H");	/*TRD0 & TRD1̃JEgJn*/

	while(1){
		driving_motor(20);	/*duty=20%*/
                wait_timer(3000);
                driving_motor(50);	/*duty=50%*/
                wait_timer(3000);
                driving_motor(100);	/*duty=100%*/
                wait_timer(3000);
        	
        	driving_motor(-20);
                wait_timer(3000);
                driving_motor(-50);
                wait_timer(3000);
                driving_motor(-100);
                wait_timer(3000);
	}
}

/*|[g*/
void port_init(void){
	/**********o̓|[g**********/
	PRCR.BIT.PRC2 = 1;		/*PD0ɏ*/
	PD0.BYTE = 0x00;		/*gpȂs͏o͂ɐݒ*/
	PD1.BYTE = 0xFF;
	PD2.BYTE = 0xFF;
	PD3.BYTE = 0xBB;
	PD4.BYTE = 0x3C;
	PD6.BYTE = 0xFF;
	
	P0.BYTE = 0x00;
	P1.BYTE = 0x00;
	P2.BYTE = 0xFF;
	P3.BYTE = 0x00;
	P4.BYTE = 0x00;
	P6.BYTE = 0x0A;
}



/* ^C}[֐ ///////////////////////////////////////////////////////////*/
/*********************************** timer functions ***********************************/
/*^C}[ݒ*/
void RD_init(void){
	/*ʐݒ*/
	TRDOER1.BIT.EB0 = 0;		/*o͋*/
	TRDOER1.BIT.EA0 = 1;
	TRDOER1.BIT.EA1 = 1;
	TRDMR.BYTE = 0x00;		/*TRDGRC/DWX^WFlWX^ƂĎgp*/
	TRDFCR.BIT.PWM3 = 1;
	TRDFCR.BIT.CMD0 = 0;
	TRDFCR.BIT.CMD1 = 0;
	
	/*chanel0*/			/*PWM[h*/
	TRDCR0.BYTE = 0x22;		/*TRDGRAOŃRyAv,f4*/
	TRDPMR.BIT.PWMB0 = 1;		/*PWM[h*/
	TRDIER0.BYTE = 0x00;		/*֎~*/ /*disable interrupt*/
	TRDOCR.BIT.TOB0 = 0;		/*o͂̓ANeBułȂx*/
	TRDPOCR0.BIT.POLB = 1;		/*TRDIOBȉo̓x'H'*/

	TRDGRA0.WORD = 100;		/*F49.5kHz*/
	TRDGRB0.WORD = 101;		/*f[eBF0%*/
	
	/*chanel1*/			/*AEgvbgRyA,^C}[荞*/
	TRDCR1.BYTE = 0x24;		/*TRDGRA1ŃRyAv,f32*/
	TRDPMR.BIT.PWMB1 = 0;		/*^C}[[h*/
	TRDIER1.BYTE = 0x01;		/*IMIA*/
	TRDIORA1.BYTE = 0x08;		/*o͋֎~*/
	TRDGRA1.WORD = 0x0270;		/*1msec*/
}


void wait_timer(const long msec2){
	asm("FSET	I");		/*,I=1*/
	asm("MOV.B	#01H,0049H");	/*TRD1IC register(wait_timer),level1*/
	msec = msec2;
	asm("OR.B	#0AH,0137H");	/*JEgJn*/
	while(msec != 0);
	asm("AND.B	#0DH,0137H");	/*JEg~*/
	asm("FCLR	I");		/*֎~,I=0*/
}

#pragma INTERRUPT timer_interrupt
void timer_interrupt(void){
	if(msec != 0){
		msec = (msec-1);
	}
	TRDSR1.BIT.IMFA = 0;		/*̊֐݂̂Őݒ*/
}


void wait(const long sec){
	volatile long k;
	for(k=0; k<200*sec; k++);
}


void driving_motor(short duty){
        if(duty > 0){
                FORWARD = 1;		 /*ԗ֑Oiw*/
                BACK    = 0;
        	if(duty < 100){
        		duty = (100 - duty);
        	}
        }
        else if(duty < 0){
                FORWARD = 0;		/*ԗ֌ގw*/
                BACK    = 1;
                duty = -duty;		/*]Ő̒l*/
        	if(duty < 100){
        		duty = (100 - duty);
        	}
        }
        else{				 /*~w*/
                FORWARD = 1;
                BACK    = 1;
        }
	if(duty > MAX_DUTY){
		duty = MAX_DUTY;	 /*f[eB̍őlݒ*/
	}

	PWM = duty;			/*PWMo*/
}


#pragma INTERRUPT rx_str0
void rx_str0(void){
	;	/*dummy*/
}


#pragma INTERRUPT rx_str0
void int0_func(void){
	;	/*dummy*/
}


#pragma INTERRUPT rx_str0
void int1_func(void){
	;	/*dummy*/
}

